//+------------------------------------------------------------------+
//|                       Steve Hopwood's BS 10 a day multi-pair.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define long "Long"
#define short "Short"
#define none "None"


/*
void DisplayUserFeedback()
start()

----Trading functions----
void LookForOpenTrades()
bool SendSingleTrade(int type, string symbol)
void GetSpread()
void GetNextRoundNumbers(string symbol)
void DoesTradeExist(string symbol)
void LookForTradingOpportunity(string symbol)

----BB----
double ReadBands(string symbol, int shift, int mode)

----Misc----

*/




extern string     bs="----Basic stuff----";
extern string     PairsToTrade = "EURUSD, GBPUSD,EURJPY,";
extern double     Lot=0.01;
extern int        MagicNumber=7183149;
extern string     TradeComment="10 a day";
extern int        MaxSpread=40;
extern int        TradeBoxHigh=700;
extern int        TradeBoxLow=300;
extern int        SleepAfterLossMins=30;
extern string     tpsl="----Take profit and stop loss in pips----";
extern int        TP=70;
extern int        SL=100;
extern string     trs="----Trading style----";
extern bool       LongTradeAllowed=true;//Allows user to disable trading
extern bool       ShortTradeAllowed=true;//Allows user to disable trading
extern bool       AlertNotTrade=false;
extern string     tt="----Trading hours----";
extern string     Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string     Trade_Hours_M= "Morning Hours 0-12";
extern  int       start_hourm = 0;
extern  int       end_hourm = 12;
extern string     Trade_Hours_E= "Evening Hours 12-24";
extern  int       start_houre = 12;
extern  int       end_houre = 24;
extern string     wei="----Week ending inputs----";
extern bool       FridayClose=false;
extern bool       SaturdayClose=false;
extern int        CloseHour = 12;
extern string     oae="----Odds and ends----";
extern int        DisplayGapSize=20;
extern bool       ShowPairsInformation=true;


//Open trades\trade direction.
bool              TradeExists;
int               NoOfTrades;


//Trading hours
bool              ClosedForFriday;
bool              ClosedForSaturday;

//Bands - counts from the top down
/*double            Line1;
double            Line2;
double            Line3;
double            Line4;
double            Line5;
string            TradingBand;//Holds the trading band that contains the Bid
*/

//Pair extraction
string            InputString;//Holds the contents PairsToTrade for tidying yp etc
int               NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string            TradePair[]; //Array to hold the pairs traded by the user
int               dBars[];


//Open trades\trade direction.
bool              TradeOpen;
int               TicketNo;
string            TradeDirection;
   

//Round numbers
double            RoundNumberHigh;
double            RoundNumberLow;

//Misc stuff
string            ScreenMessage, Gap;
int               NewsBars, OldBars, Decimals;
bool              RobotDisabled;
string            DisabledMessage;
int               Spread;


void DisplayUserFeedback()
{
   ScreenMessage = "";
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Take profit = ", TP, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss = ", SL, NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number = ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment = ", TradeComment, NL);
   if (LongTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trading is allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trading is disabled", NL);
   if (ShortTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trading is allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trading is disabled", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxSpread = ", MaxSpread, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "TradeBoxHigh = ", TradeBoxHigh, ": TradeBoxLow = ", TradeBoxLow, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "SleepAfterLossMins = ", SleepAfterLossMins, ": TradeBoxLow = ", TradeBoxLow, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   
   ScreenMessage= StringConcatenate(ScreenMessage, NL);

   if (ShowPairsInformation)
   {
      for (int cc = 0; cc < NoOfPairs; cc++)
      {
         string symbol = TradePair[cc];         
         double Line1 = ReadBands(symbol, 0, MODE_UPPER);//now
         double Line5 = ReadBands(symbol, 0, MODE_LOWER);//now
         double Line1.1 = ReadBands(symbol, 1, MODE_UPPER);//1 candle ago
         double Line1.2 = ReadBands(symbol, 2, MODE_UPPER);//2 candle ago
         double Line5.1 = ReadBands(symbol, 1, MODE_LOWER);//1 candle ago
         double Line5.2 = ReadBands(symbol, 2, MODE_LOWER);//2 candle ago
         GetNextRoundNumbers(symbol);
         int digits = MarketInfo(symbol, MODE_DIGITS);
         ScreenMessage = StringConcatenate(ScreenMessage, Gap, symbol, 
                         ": Round numbers = ", RoundNumberHigh,
                         " ", RoundNumberLow,
                         ": Bands: Now ", DoubleToStr(Line1, digits),
                         " ", DoubleToStr(Line5, digits),
                         ": 1 candle ago ", DoubleToStr(Line1.1, digits),
                         " ", DoubleToStr(Line5.1, digits),
                         ": 2 candles ago ", DoubleToStr(Line1.2, digits),
                         " ", DoubleToStr(Line5.2, digits),
                         " Spread = ", MarketInfo(symbol, MODE_SPREAD), 
                         NL);
                         
                         
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)
   

   Comment(ScreenMessage);
}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 7183149)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 7183149." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   //4 digit crim cleanup
   if (Digits == 2 || Digits == 4)
   {
      MaxSpread/= 10;
      TP/= 10;
      SL/= 10;
      TradeBoxHigh/= 10;
      TradeBoxLow/= 10;
   }//if (Digits == 2 || Digits == 4)

   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   double iNew3 = ArrayResize(dBars, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         
         LastIndex = Index+1;
         dBars[cc] = iBars(TradePair[cc], 0);
         GetNextRoundNumbers(TradePair[cc]);
         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   if (NoOfTrades == 0) OldBars = iBars(NULL, 0);

         
   Comment(".........Waiting for a tick");
   DisplayUserFeedback();
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {

    Comment("");
    
    return(0);

  }
  

void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   NoOfPairs = 0;
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()





void DoesTradeExist(string symbol)
{
   //Searches for open trades
   TradeExists = false;
   TicketNo = 0;
   
   
   if (OrdersTotal() == 0) return; //nothing to do
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol ) 
      {
         TicketNo = OrderTicket();
         TradeExists = true;
         return;         
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol)       
   }//for (int cc = OrdersTotal() - 1; cc >= 0, cc--)  
   
}//End void DoesTradeExist(string symbol)



bool SendSingleTrade(int type, string symbol)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   // Check spread
   if (MarketInfo(symbol, MODE_SPREAD) > MaxSpread)
   {
      return(false);// Spread too large, so abort send
   }//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpreadAllowed)
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   
   double StopLoss, TakeProfit;
      
   // Buy trade
   if (type == 0)
   {
      double TradePrice=ask;
      StopLoss = NormalizeDouble(TradePrice - SL * point, digits);
      TakeProfit = NormalizeDouble(TradePrice + TP * point, digits);
      int colour = 32768;//green
   }//if (type == 0)   
   

   // Sell trade
   if (type == 1)
   {
      TradePrice=bid;      
      StopLoss = NormalizeDouble(TradePrice + SL * point, digits);
      TakeProfit = NormalizeDouble(TradePrice - TP * point, digits);
      colour = 255;//red      
   }//if (type == 1)
   

   
   int slippage = 0;
   if (digits == 3 || digits == 5) slippage = 100;
   
   int ticket = OrderSend(symbol,type, Lot, TradePrice, slippage, StopLoss, TakeProfit, TradeComment, MagicNumber, 0, colour);
   if (ticket < 0)
   {
      int err=GetLastError();
      if (err == 130) return;
      Alert("10 a day ", symbol, " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      Sleep(5000);
      return(false);
   }//if (ticket < 0)
   else Sleep(1000);//5 second   
   
   return(true);
   
}//End bool SendSingleTrade(int type, string symbol)




void GetNextRoundNumbers(string symbol)
{
   //Finds the nearest big numbers to the market price.
   //Saves these in RoundNumberHigh[index] and RoundNumberLow[index]
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   int digits = MarketInfo(symbol, MODE_DIGITS);

   //Jpy pairs
   if (digits == 2 || digits == 3)
   {
      
      int price = ask;//Truncates the quote
      RoundNumberLow = price;
      RoundNumberHigh = price + 1;
      
            
   }//if (Digits == 2 || Digits == 3)

   //non-Jpy pairs
   if (digits == 4 || digits == 5)
   {
      
      string sprice = DoubleToStr(ask, digits);
      if (ask < 10) sprice = StringSubstr(sprice, 0, 4);       
      if (ask >= 10) sprice = StringSubstr(sprice, 0, 5);       
      RoundNumberLow = StrToDouble(sprice);
      price = StrToDouble(sprice) + 0.01;
      RoundNumberHigh = price;
      
      
      
   }//if (Digits == 4 || Digits == 5)


}//End void GetNextRoundNumbers(string symbol)

void LookForTradingOpportunity(string symbol)
{
   /*
      Trading conditions:
         * two consecutive candles must have closed above\below BB lines 1 & 5
         * market must be in the TradeBoxHigh/Low box away from the next round numbers
         * <2 consecutive losing trades
   */

   TradeDirection = none;
   
   //Check for consecutive losers
   if (OrdersHistoryTotal() > 0)
   {
      int ticket, loss_trades;
      for (int cc = 0; cc <= OrdersHistoryTotal(); cc++)
      {
         if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
         if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         {
            if (OrderProfit() >= 0) loss_trades = 0;
            if (OrderProfit() < 0)
            {
               loss_trades++;
               ticket = OrderTicket();
            }//if (OrderProfit() < 0)            
         }//if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)         
      }//for (int cc = 0; cc <= OrdersHistoryTotal(); cc++)
      
      if (loss_trades > 1)
      {
         OrderSelect(ticket, SELECT_BY_TICKET, MODE_HISTORY);//Most recent losing trade
         int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
         if (TimePassed < SleepAfterLossMins) return;//Too soon after trade loss closure
      }//if (loss_trades > 1)      
   }//if (OrdersHistoryTotal() > 0)
   
   //Not 2 consecutive losers, so look for trading opps
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   //Get a possible direction
   
   double Line1.1 = ReadBands(symbol, 1, MODE_UPPER);//1 candle ago
   double Line1.2 = ReadBands(symbol, 2, MODE_UPPER);//2 candle ago
   double Line5.1 = ReadBands(symbol, 1, MODE_LOWER);//1 candle ago
   double Line5.2 = ReadBands(symbol, 2, MODE_LOWER);//2 candle ago
         
      
   //Short   
   if (iClose(symbol, NULL, 1) > Line1.1 && iClose(symbol, NULL, 2) > Line1.2)
   {
      RefreshRates();
      GetNextRoundNumbers(symbol);
      double bid = MarketInfo(symbol, MODE_BID);
      if (bid > NormalizeDouble(RoundNumberHigh + (TradeBoxHigh * point), digits) )
      {
         TradeDirection = short;
         return;
      }//if (bid > NormalizeDouble(RoundNumberLow[index] + (TradeBoxLow * point), digits) )
      
   }//if (iClose(symbol, NULL, 1) > Line1 && iClose(symbol, NULL, 2) > Line1)
   
   //Long   
   if (iClose(symbol, NULL, 1) < Line5.1 && iClose(symbol, NULL, 2) < Line5.2)
   {
      RefreshRates();
      GetNextRoundNumbers(symbol);
      double ask = MarketInfo(symbol, MODE_ASK);
      if (ask < NormalizeDouble(RoundNumberLow - (TradeBoxLow * point), digits) )
      {
         TradeDirection = long;
         return;
      }//if (ask < NormalizeDouble(RoundNumberHigh[index] - (TradeBoxHigh * point), digits) )
      
   }//if (iClose(symbol, NULL, 1) < Line5 && iClose(symbol, NULL, 2) < Line5)
   
   

}//End void LookForTradingOpportunity(string symbol)

double ReadBands(string symbol, int shift, int mode)
{
   //Read the values of the bollinger bands line required
   
   
   //Only need top and bottom lines for this robot
   return(iBands(symbol, 0, 20, 2, 0, PRICE_CLOSE, mode, shift) );
   
   
   
}//End double ReadBands(string symbolint shift, int mode)


//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )


     //Check Friday close
     if (FridayClose)
     {
        ClosedForFriday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
        {
           ClosedForFriday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (FridayClose)
        
     //Check Saturday close for Aitipodeans
     if (SaturdayClose)
     {
        ClosedForSaturday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
        {
           ClosedForSaturday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (Saturday)

      
   //Trading hours
   bool TradeHour = false;
   if ((Hour()>=start_hourm && Hour()<end_hourm) || (Hour()>=start_houre && Hour()<end_houre)) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours.");
      return;
   }//if (!TradeHour)

    //Look for trading opportunities
    for(int cc = 0; cc < ArraySize(TradePair); cc++)
    {

      string symbol = TradePair[cc];//Does nothing more than make typing easier

      
               
      RefreshRates();
      double ask = MarketInfo(symbol, MODE_ASK);
      double bid = MarketInfo(symbol, MODE_BID);
      double point = MarketInfo(symbol, MODE_POINT);
      double digits = MarketInfo(symbol, MODE_DIGITS);
   
      
      //Check for open trades. Their ticket numbers are stored in variables set up for the purpose
      DoesTradeExist(symbol);

   
            
       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
       
        
       if(iClose(TradePair[cc],0,0) > 0)
       {      
            
            if (TradeExists) continue;
            
            //Check for start of new candle
            if (dBars[cc] == iBars(TradePair[cc], 0) ) continue;
            dBars[cc] = iBars(TradePair[cc], 0);
            
            TradeDirection = none;
            
            
            //Overriding filters ok, so continue
            bool TradeAllowed = true;
            
            //Set TradeDirection to Long, Short or None
            LookForTradingOpportunity(symbol);
            
            if (TradeDirection == none) TradeAllowed = false;
            
            
            //Abort if trading has been disallowed for any reason
            if (!TradeAllowed) continue;
            
            
            if (IsTradeAllowed() )
            {                    
               
               bool TradeSuccess;
               
               if (TradeDirection == long && LongTradeAllowed)
               {
                  if (AlertNotTrade) Alert("10 a day ", symbol, " Long trade is available");
                  else
                  {
                     TradeSuccess = SendSingleTrade(0, symbol);                     
                  }//else               
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;
      
               if (TradeDirection == short && ShortTradeAllowed)
               {
                  if (AlertNotTrade) Alert("10 a day ", symbol, " Short trade is available");
                  else
                  {               
                     TradeSuccess = SendSingleTrade(1, symbol);                     
                  }//else
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;         
               
            }//if (IsTradeAllowed)        
      
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


