//+------------------------------------------------------------------+
//|                   Steve Hopwood's BS Round Number multi-pair.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property show_inputs
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define long "Long"
#define short "Short"
#define none "None"


/*
void DisplayUserFeedback()
start()

----Trading functions----
void LookForOpenTrades()
bool SendSingleTrade(int type, string symbol)
void GetSpread()
void GetNextRoundNumbers(string symbol)
void DoesTradeExist(string symbol)
void LookForTradingOpportunity(string symbol)

----Management----
void ManageTrades(string symbol)


----Misc----

*/




extern string     bs="----Basic stuff----";
extern string     PairsToTrade = "AUDCAD,AUDCHF,AUDNZD,AUDJPY,AUDUSD,CADCHF,CADJPY,CHFJPY,EURAUD,EURCAD,EURCHF,EURGBP,EURNZD,EURJPY,EURUSD,GBPCHF,GBPJPY,GBPUSD,NZDUSD,NZDJPY,USDCAD,USDCHF,USDJPY,USDSGD";
extern double     Lot=0.02;
extern int        MagicNumber=615046;
extern string     TradeComment="Round numbers";
extern int        MaxSpread=100;
extern string     tpsl="----Stop loss and half-close target in pips----";
extern int        SL=600;
extern int        HcTarget = 250;
extern int        BEP=20;
extern string     trs="----Trading style----";
extern bool       LongTradeAllowed=true;//Allows user to disable trading
extern bool       ShortTradeAllowed=true;//Allows user to disable trading
extern bool       AlertNotTrade=false;
extern string     JSL="----Jumping stop loss----";
extern bool       JumpingStop=true;
extern int        JumpingStopPips=100;
extern string     tt="----Trading hours----";
extern string     Trade_Hours= "Set Morning & Evening Hours 24hr";
extern string     Trade_Hours_M= "Morning Hours 0-12";
extern  int       start_hourm = 0;
extern  int       end_hourm = 12;
extern string     Trade_Hours_E= "Evening Hours 12-24";
extern  int       start_houre = 12;
extern  int       end_houre = 24;
extern string     wei="----Week ending inputs----";
extern bool       FridayClose=false;
extern bool       SaturdayClose=false;
extern int        CloseHour = 12;
extern string     dins="----Pair display settings----";
extern bool       ShowPairsInformation=true;
extern color      PairColour=Yellow;
extern color      HighColour=Green;
extern color      LowColour=Red;
extern color      SpreadColour=Turquoise;
extern double     DisplayHorizontalStart=80;
extern double     DisplayVerticalStart=12.2;
extern string     oae="----Odds and ends----";
extern int        DisplayGapSize=30;


//Open trades\trade direction.
bool              TradeExists;
int               NoOfTrades;


//Trading hours
bool              ClosedForFriday;
bool              ClosedForSaturday;


//Pair extraction
string            InputString;//Holds the contents PairsToTrade for tidying yp etc
int               NoOfPairs;// Holds the number of pairs passed by the user via the inputs screen
string            TradePair[]; //Array to hold the pairs traded by the user
int               dBars[];


//Open trades\trade direction.
bool              TradeOpen;
int               TicketNo;
string            TradeDirection;
   

//Round numbers
double            RoundNumberHigh;
double            RoundNumberLow;

//Misc stuff
string            ScreenMessage, Gap;
int               NewsBars, OldBars, Decimals;
bool              RobotDisabled;
string            DisabledMessage;
int               Spread;


void DisplayUserFeedback()
{
   ScreenMessage = "";
   
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Lot size = ", Lot, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Stop loss = ", SL, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Half-close target = ", HcTarget, " pips", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Break even profit = ", BEP, " pips", NL);
   if(JumpingStop) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Jumping stop = ", JumpingStopPips, " pips", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Not using a Jumping stop", NL);
   ScreenMessage = StringConcatenate(ScreenMessage,Gap, "Magic number = ", MagicNumber, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Trade comment = ", TradeComment, NL);
   if (LongTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trading is allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Long trading is disabled", NL);
   if (ShortTradeAllowed) ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trading is allowed", NL);
   else ScreenMessage = StringConcatenate(ScreenMessage, Gap, "Short trading is disabled", NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "MaxSpread = ", MaxSpread, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour start = ", start_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "AM trade hour end = ", end_hourm, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour start = ", start_houre, NL);
   ScreenMessage = StringConcatenate(ScreenMessage, Gap, "PM trade hour end = ", end_houre, NL);
   if (FridayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Friday close = ", DoubleToStr(CloseHour, 2), NL);
   if (SaturdayClose) ScreenMessage= StringConcatenate(ScreenMessage, Gap, "Saturday close = ", DoubleToStr(CloseHour, 2), NL);
   
   ScreenMessage= StringConcatenate(ScreenMessage, NL);
   Comment(ScreenMessage);
   
   if (ShowPairsInformation)
   {
      int v_size=7;
      double vertical = DisplayVerticalStart;
      vertical+= 0.8;
      double horizontal;
      string Label_Name;
      
      //Headings
      horizontal = DisplayHorizontalStart + 60;
      vertical+= 0.8;         
      Label_Name = "headlabel"+"a";
      Printtxt("High",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;
            
      Label_Name = "headlabel"+"b";
      Printtxt("Low",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;

      Label_Name = "headlabel"+"c";
      Printtxt("Ask",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;

      Label_Name = "headlabel"+"d";
      Printtxt("Bid",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;

      Label_Name = "headlabel"+"e";
      Printtxt("Spread",Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
      horizontal+= 60;

      for (int cc = 0; cc < NoOfPairs; cc++)
      {
         string symbol = TradePair[cc];         
         double digits = MarketInfo(symbol, MODE_DIGITS);
         GetNextRoundNumbers(symbol);
         horizontal = DisplayHorizontalStart;
         color v_color=Yellow;
         vertical+= 0.8;
         Label_Name = "mylabel"+DoubleToStr(cc,0)+"a";
         Printtxt(symbol,Label_Name,v_size,"Arial", PairColour,vertical,horizontal);
         horizontal+= 60;

         int Decimals;
         if (digits == 2 || digits == 3) Decimals = 0;
         if (digits == 4 || digits == 5) Decimals = 2;
         
         Label_Name = "mylabel"+DoubleToStr(cc,0)+"b";
         Printtxt(DoubleToStr(RoundNumberHigh, Decimals), Label_Name,v_size,"Arial", HighColour,vertical,horizontal);
         horizontal+= 60;

         Label_Name = "mylabel"+DoubleToStr(cc,0)+"c";
         Printtxt(DoubleToStr(RoundNumberLow, Decimals), Label_Name,v_size,"Arial", LowColour,vertical,horizontal);
         horizontal+= 60;

         Label_Name = "asklabel"+DoubleToStr(cc,0) +"x";
         Printtxt(DoubleToStr(MarketInfo(symbol, MODE_ASK), digits), Label_Name, v_size,"Arial", HighColour,vertical,horizontal);
         horizontal+= 60;        

         Label_Name = "bidlabel"+DoubleToStr(cc,0) +"x";
         Printtxt(DoubleToStr(MarketInfo(symbol, MODE_BID), digits), Label_Name, v_size,"Arial", LowColour,vertical,horizontal);
         horizontal+= 60;        

         Label_Name = "spreadlabel"+DoubleToStr(cc,0) +"x";
         Printtxt(DoubleToStr(MarketInfo(symbol, MODE_SPREAD), 0), Label_Name, v_size,"Arial", SpreadColour,vertical,horizontal);
         horizontal+= 60;        
   
                         
      }//for (cc = 0; cc < NoOfCurrencies; cc==)
   }//if (ShowPairsInformation)
   


}//void DisplayUserFeedback()


//+------------------------------------------------------------------+
//| expert Initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {

   if (!IsDemo() )
   {
      if (MagicNumber == 615046)
      {
         MessageBox("You cannot run this robot until changed the MagicNumber input from the default of 615046." + NL 
                    + "Please reload the robot with a new MagicNumber input.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to change the MagicNumber input";
         RobotDisabled = true;
         return;
      }//if (MagicNumber == 4872635)
      
      //Insufficient length
      string mn = DoubleToStr(MagicNumber,0);
      if (StringLen(mn) < 5)
      {
         MessageBox("Your MagicNumber input needs to be at least 5 digits long, Your MagicNumber is " + mn + NL 
                    + "Please reload the robot with the MagicNumber input containing at least 5 digits - the more the better.");
         Comment("                This robot can do nothing. Please reload it");
         DisabledMessage = "You need to make the MagicNumber input at 5 digits long - more is better";
         RobotDisabled = true;
         return;
      }//if (StringLen(mn) < 5)     
      
   }//if (!IsDemo)
   
   //4 digit crim cleanup
   if (Digits == 2 || Digits == 4)
   {
      MaxSpread/= 10;
      SL/= 10;
      HcTarget/= 10;
      JumpingStopPips/= 10;
      
   }//if (Digits == 2 || Digits == 4)

   
   //Extract the pairs traded by the user
   // Cleanup first
   InputString=PairsToTrade;
   CleanUpInputString();
   
   // Extract the number of paraaters passed by the user
   CalculatePairsPassed();
   
   string AddChar = StringSubstr(Symbol(),6,4);
   
   // Resize the arrays appropriately
   string NewArray = ArrayResize(TradePair, NoOfPairs);
   double iNew3 = ArrayResize(dBars, NoOfPairs);
   
   int Index = 0;//For searching InputString
   int LastIndex = 0;//Points the the most recent Index
   for (int cc = 0; cc < NoOfPairs; cc ++)
   {
      Index = StringFind(InputString, ",",LastIndex);
      if (Index > -1)
      {
         TradePair[cc] = StringSubstr(InputString, LastIndex,Index-LastIndex);
         TradePair[cc] = StringTrimLeft(TradePair[cc]);
         TradePair[cc] = StringTrimRight(TradePair[cc]);
         TradePair[cc] = StringConcatenate(TradePair[cc], AddChar);
         
         
         LastIndex = Index+1;
         dBars[cc] = iBars(TradePair[cc], 0);
         GetNextRoundNumbers(TradePair[cc]);
         
      }//if (Index > -1)            
   }//for (int cc; cc<NoOfPairs; cc ++)

    int Step = MarketInfo(Symbol(),MODE_LOTSTEP);
    
    if(Step == 0.01) Decimals = 2;
    if(Step == 0.10) Decimals = 1;
    if(Step == 1.00) Decimals = 0;
    
    
   Gap="";
   if (DisplayGapSize >0)
   {
      for (cc=0; cc< DisplayGapSize; cc++)
      {
         Gap = StringConcatenate(Gap, " ");
      }   
   }
   
   if (NoOfTrades == 0) OldBars = iBars(NULL, 0);

         
   Comment(".........Waiting for a tick");
   DisplayUserFeedback();
   
   return(0);
    
  }
  
//+------------------------------------------------------------------+
//| expert Deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
{

    Comment("");
    ObjectsDeleteAll(0, OBJ_LABEL);
    return(0);

}

void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + horizontal);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * vertical);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {

void CleanUpInputString()
{
   // Does any tidying up of the user inputs
   
   //Remove unwanted spaces
   InputString = StringTrimLeft(InputString);
   InputString = StringTrimRight(InputString);

   //Add final comma if ommitted by user
   if (StringSubstr(InputString, StringLen(InputString)-1) != ",") 
      InputString = StringConcatenate(InputString,",");
      
   
}//void CleanUpInputString

void CalculatePairsPassed()
{
   // Calculates the numbers of paramaters passed in LongMagicNumber and TradeComment.
   
   int Index = 0;//For searching NoTradePairs
   int LastIndex;//Points the the most recent Index
   
   while(Index > -1)
      {
         Index = StringFind(InputString, ",",LastIndex);
         if (Index > -1)
         {
            NoOfPairs ++;
            LastIndex = Index+1;            
         }//if (Index > -1)
      }//while(int cc > -1)
   
   
   
}//End void CalculatePairsPassed()





void DoesTradeExist(string symbol)
{
   //Searches for open trades
   TradeExists = false;
   TicketNo = 0;
   
   
   if (OrdersTotal() == 0) return; //nothing to do
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol ) 
      {
         TicketNo = OrderTicket();
         TradeExists = true;
         return;         
      }//if (OrderMagicNumber() == MagicNumber && OrderSymbol() == symbol)       
   }//for (int cc = OrdersTotal() - 1; cc >= 0, cc--)  
   
}//End void DoesTradeExist(string symbol)



bool SendSingleTrade(int type, string symbol)
{
   // Attempts to place a trade according to type, i.e.
   // 0 = OP_BUY
   // 1 = OP_SELL
   
   // Check spread
   if (MarketInfo(symbol, MODE_SPREAD) > MaxSpread)
   {
      return(false);// Spread too large, so abort send
   }//if (MarketInfo(NULL, MODE_SPREAD) > MaxSpreadAllowed)
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   
   double StopLoss, TakeProfit;
      
   // Buy trade
   if (type == 0)
   {
      double TradePrice=ask;
      StopLoss = NormalizeDouble(TradePrice - SL * point, digits);
      int colour = 32768;//green
   }//if (type == 0)   
   

   // Sell trade
   if (type == 1)
   {
      TradePrice=bid;      
      StopLoss = NormalizeDouble(TradePrice + SL * point, digits);
      colour = 255;//red      
   }//if (type == 1)
   

   
   int slippage = 0;
   if (digits == 3 || digits == 5) slippage = 100;
   
   int ticket = OrderSend(symbol,type, Lot, TradePrice, slippage, StopLoss, 0, TradeComment, MagicNumber, 0, colour);
   if (ticket < 0)
   {
      int err=GetLastError();
      if (err == 130) return;
      Alert("Round number ", symbol, " ", type," order send failed with error(",err,"): ",ErrorDescription(err));
      Print("Order send failed with error(",err,"): ",ErrorDescription(err));
      Sleep(5000);
      return(false);
   }//if (ticket < 0)
   else Sleep(1000);//5 second   
   
   return(true);
   
}//End bool SendSingleTrade(int type, string symbol)




void GetNextRoundNumbers(string symbol)
{
   //Finds the nearest big numbers to the market price.
   //Saves these in RoundNumberHigh[index] and RoundNumberLow[index]
   
   RefreshRates();
   double ask = MarketInfo(symbol, MODE_ASK);
   double bid = MarketInfo(symbol, MODE_BID);
   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);

   //Jpy pairs
   if (digits == 2 || digits == 3)
   {
      int price = ask;//Truncates the quote
      RoundNumberLow = price;
      RoundNumberHigh = price + 1;
      
            
   }//if (Digits == 2 || Digits == 3)

   //non-Jpy pairs
   if (digits == 4 || digits == 5)
   {
      
      string sprice = DoubleToStr(ask, digits);
      if (ask >= 10) sprice = StringSubstr(sprice, 0, 5);       
      if (ask < 10) sprice = StringSubstr(sprice, 0, 4);       
      RoundNumberLow = StrToDouble(sprice);
      RoundNumberHigh = RoundNumberLow + 0.01;
      
      
      
   }//if (Digits == 4 || Digits == 5)


}//End void GetNextRoundNumbers(string symbol)

void LookForTradingOpportunity(string symbol)
{
   /*
      Trading conditions:
         * two consecutive candles must have closed above\below BB lines 1 & 5
         * market must be in the TradeBoxHigh/Low box away from the next round numbers
         * <2 consecutive losing trades
   */

   TradeDirection = none;
   
/*   //Check for consecutive losers
   if (OrdersHistoryTotal() > 0)
   {
      int ticket, loss_trades;
      for (int cc = 0; cc <= OrdersHistoryTotal(); cc++)
      {
         if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
         if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)
         {
            if (OrderProfit() >= 0) loss_trades = 0;
            if (OrderProfit() < 0)
            {
               loss_trades++;
               ticket = OrderTicket();
            }//if (OrderProfit() < 0)            
         }//if (OrderSymbol() == symbol && OrderMagicNumber() == MagicNumber)         
      }//for (int cc = 0; cc <= OrdersHistoryTotal(); cc++)
      
      if (loss_trades > 1)
      {
         OrderSelect(ticket, SELECT_BY_TICKET, MODE_HISTORY);//Most recent losing trade
         int TimePassed = (TimeCurrent() - OrderCloseTime()) / 60;
         if (TimePassed < SleepAfterLossMins) return;//Too soon after trade loss closure
      }//if (loss_trades > 1)      
   }//if (OrdersHistoryTotal() > 0)
   
   //Not 2 consecutive losers, so look for trading opps
*/

   double point = MarketInfo(symbol, MODE_POINT);
   double digits = MarketInfo(symbol, MODE_DIGITS);
   //Get a possible direction
   
      
      
   //Short   
   RefreshRates();
   GetNextRoundNumbers(symbol);
   double bid = MarketInfo(symbol, MODE_BID);
   if (bid < RoundNumberLow && iClose(symbol, PERIOD_M1, 1) > RoundNumberLow)
   {
      TradeDirection = short;
      return;
   }//if (bid > NormalizeDouble(RoundNumberLow[index] + (TradeBoxLow * point), digits) )
      
   
   //Long   
   double ask = MarketInfo(symbol, MODE_ASK);
   if (ask > RoundNumberHigh && iClose(symbol, PERIOD_M1, 1) < RoundNumberHigh)
   {
      TradeDirection = long;
      return;
      }//if (ask < NormalizeDouble(RoundNumberHigh[index] - (TradeBoxHigh * point), digits) )
      
   
   

}//End void LookForTradingOpportunity(string symbol)

void ManageTrades(string symbol)
{
   //Manage moving stops to be and closing half the trade.
   //Trailing stop on the remainder of the trade
   
   
   while (!IsTradeAllowed() )
   {
      Comment("Trying to manage trades, but trading not allowed by the criminal");
   }//while (!IsTradeAllowed() )
               
   if (!OrderSelect(TicketNo, SELECT_BY_TICKET) )return;//Trade has closed, so nothing to do
   
   if (OrderProfit() > 0 && OrderLots() > Lot / 2)
   {
      bool result = false;
      double CloseLots = OrderLots() / 2;
      int digits =  MarketInfo(symbol, MODE_DIGITS);
      double point = MarketInfo(symbol, MODE_POINT);
      RefreshRates();
      double bid = MarketInfo(symbol, MODE_BID);
      double ask = MarketInfo(symbol, MODE_ASK);
         
      if (OrderType() == OP_BUY)
      {
         if (ask >= NormalizeDouble(OrderOpenPrice() + HcTarget * point, digits) )
         {
            result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
            if (!result)
            {
                 int err=GetLastError();
                 Alert(symbol, " Round Number ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                 return;
            }//if (!result)
            //Get new ticket number
            Sleep(100);
            DoesTradeExist(symbol);
            OrderSelect(TicketNo, SELECT_BY_TICKET);
            
         }//if (ask >= NormalizeDouble(OrderOpenPrice() + HcTarget, digits) )
         
      }//if (OrderType() == OP_BUY)
      
      if (OrderType() == OP_SELL)
      {
         if (bid <= NormalizeDouble(OrderOpenPrice() - HcTarget * point, digits) )
         {   
            result = OrderClose(OrderTicket(), CloseLots, OrderClosePrice(), 500, CLR_NONE);
            if (!result)
            {
                 err=GetLastError();
                 Alert(symbol, " Round Number robot ", OrderType()," part-close failed with error(",err,"): ",ErrorDescription(err));
                 return;
            }//if (!result)
            //Get new ticket number
            Sleep(100);
            DoesTradeExist(symbol);
            OrderSelect(TicketNo, SELECT_BY_TICKET);
            
         }//if (bid <= NormalizeDouble(OrderOpenPrice() - HcTarget, digits) )
      }//if (OrderType() == OP_SELL)
      
               
   }//if (OrderProfit() > 0 && OrderLots() > Lot / 2)
   
   
   //Move stops to breakeven. Also mops up failed stop move attempts.
   if (OrderType() == OP_BUY) 
   {
      if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lot)
      {
         double SL = NormalizeDouble(OrderOpenPrice() + (BEP * point), digits);
         result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
         if (!result)
          {
              err=GetLastError();
              Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
              return;
          }//if (!result)     
      }//if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lots)
   }//if (OrderType() == OP_BUY) 
   
   if (OrderType() == OP_SELL)
   {
      if (OrderStopLoss() > OrderOpenPrice() && OrderLots() < Lot)
      {
         SL = NormalizeDouble(OrderOpenPrice() - (BEP * point), digits);
         result = OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, CLR_NONE);
         if (!result)
          {
              err=GetLastError();
              Alert(OrderSymbol(), " Trend retracement robot ", OrderType(), " Stop loss move failed with error(",err,"): ",ErrorDescription(err));
              return;
          }//if (!result)     
      }//if (OrderStopLoss() < OrderOpenPrice() && OrderLots() < Lots)
      
   }//if (OrderType() == OP_SELL)

   //Jumping stop
   if (JumpingStop)
   {
      double sl=OrderStopLoss(); //Stop loss
      if (OrderType()==OP_BUY && OrderLots() < Lot)
      {  
         // Increment sl by sl + JumpingStopPips.
         // This will happen when market price >= (sl + JumpingStopPips)
         if (ask >= sl + (JumpingStopPips * point) && sl >= OrderOpenPrice() )      
         {
            sl = NormalizeDouble(sl+(JumpingStopPips*point), digits);
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);
             
         }//if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())      
      }//if (OrderType()==OP_BUY && OrderLots() < Lot)
   
      if (OrderType()==OP_SELL && OrderLots() < Lot)
      {      
         // Decrement sl by sl - JumpingStopPips.
         // This will happen when market price <= (sl - JumpingStopPips)
         if (bid <= sl - (JumpingStopPips * point) && sl <= OrderOpenPrice() )
         {
            sl=NormalizeDouble(sl-(JumpingStopPips*point), digits);
            result = OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,CLR_NONE);            
         }//if (bid>= sl + (JumpingStopPips*point) && sl>= OrderOpenPrice())         
      }//if (OrderType()==OP_SELL && OrderLots() < Lot)
   
  }//if (JumpingStop)
    
}//End void ManageTrades(string symbol)



//+------------------------------------------------------------------+
//| expert Start function                                            |
//+------------------------------------------------------------------+

int start()
{
    
   if (RobotDisabled )
   {
      Comment("The robot has been suspended. Reason: ", DisabledMessage);
      return;
   }//if (RobotDisabled )


     //Check Friday close
     if (FridayClose)
     {
        ClosedForFriday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 5)
        {
           ClosedForFriday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (FridayClose)
        
     //Check Saturday close for Aitipodeans
     if (SaturdayClose)
     {
        ClosedForSaturday = false;
        if (TimeHour(TimeLocal() ) >= CloseHour && TimeDayOfWeek(TimeLocal() ) == 6)
        {
           ClosedForSaturday = true;
           DisplayUserFeedback();
           return;
        }//if (TimeHour(TimeLocal()) >= CloseHour && DayOfWeek() == 5)
     }//if (Saturday)

      
   //Trading hours
   bool TradeHour = false;
   if ((Hour()>=start_hourm && Hour()<end_hourm) || (Hour()>=start_houre && Hour()<end_houre)) TradeHour = true;
   if (!TradeHour)
   {
      Comment(Gap, "Trading suspended - outside trade hours.");
      return;
   }//if (!TradeHour)

    //Look for trading opportunities
    for(int cc = 0; cc < ArraySize(TradePair); cc++)
    {

      string symbol = TradePair[cc];//Does nothing more than make typing easier

      
               
      RefreshRates();
      double ask = MarketInfo(symbol, MODE_ASK);
      double bid = MarketInfo(symbol, MODE_BID);
      double point = MarketInfo(symbol, MODE_POINT);
      double digits = MarketInfo(symbol, MODE_DIGITS);
   
      
      //Check for open trades. Their ticket numbers are stored in variables set up for the purpose
      DoesTradeExist(symbol);
      if (TradeExists) ManageTrades(symbol);
   
            
       if (!IsTradeAllowed())
       {
            Comment("Trading disabled by the criminal pillock. Please wait for him to get out of bed.");
            return;
       }//if (!IsTradeAllowed)
       
        
       if(iClose(TradePair[cc],0,0) > 0)
       {      
            
            if (TradeExists) continue;
            
            //Check for start of new candle
            if (dBars[cc] == iBars(TradePair[cc], 0) ) continue;
            dBars[cc] = iBars(TradePair[cc], 0);
            
            TradeDirection = none;
            
            
            //Overriding filters ok, so continue
            bool TradeAllowed = true;
            
            //Set TradeDirection to Long, Short or None
            LookForTradingOpportunity(symbol);
            
            if (TradeDirection == none) TradeAllowed = false;
            
            
            //Abort if trading has been disallowed for any reason
            if (!TradeAllowed) continue;
            
            
            if (IsTradeAllowed() )
            {                    
               
               bool TradeSuccess;
               
               if (TradeDirection == long && LongTradeAllowed)
               {
                  if (AlertNotTrade) Alert("Round Number ", symbol, " Long trade is available");
                  else
                  {
                     TradeSuccess = SendSingleTrade(0, symbol);                     
                  }//else               
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;
      
               if (TradeDirection == short && ShortTradeAllowed)
               {
                  if (AlertNotTrade) Alert("Round Number ", symbol, " Short trade is available");
                  else
                  {               
                     TradeSuccess = SendSingleTrade(1, symbol);                     
                  }//else
               }//if (Ask - HighestSma > 10 * Point) TradeDirection = long;         
               
            }//if (IsTradeAllowed)        
      
         }//if(iClose(TradePair[cc],0,0) > 0)
      
      }//for(int cc = 0; cc < ArraySize(TradePair); cc++)
    
    DisplayUserFeedback();
      
    return(0);

}//End start()


